// This code was generated by a tool.
// Processing tool available at https://github.com/mezoni/binary_generator

part of libc.libc_library;

class LibC {
  DynamicLibrary _library;
  
  /**
   *
   */
  LibC(DynamicLibrary library) { 
    var headers = <String>["assert.h", "complex.h", "ctype.h", "errno.h", "fenv.h", "float.h", "inttypes.h", "iso646.h", "limits.h", "locale.h", "math.h", "setjmp.h", "signal.h", "stdarg.h", "stdbool.h", "stddef.h", "stdint.h", "stdlib.h", "stdio.h", "string.h", "tgmath.h", "time.h", "wchar.h", "wctype.h"];
    var types = library.types;
    var helper = new BinaryTypeHelper(types); 
    for (var header in headers) {
      helper.declare(header);    
    }
  
    library.link(headers);
    _library = library;
  }
  
  /**
   * void clearerr(FILE *)
   */
  void clearerr(stream) {
    return _library.invoke("clearerr", [stream]);
  }
  
  /**
   * int fclose(FILE *)
   */
  int fclose(stream) {
    return _library.invoke("fclose", [stream]);
  }
  
  /**
   * FILE * fdopen(int, char *)
   */
  BinaryData fdopen(int filedes, opentype) {
    return _library.invoke("fdopen", [filedes, opentype]);
  }
  
  /**
   * int feof(FILE *)
   */
  int feof(stream) {
    return _library.invoke("feof", [stream]);
  }
  
  /**
   * int ferror(FILE *)
   */
  int ferror(stream) {
    return _library.invoke("ferror", [stream]);
  }
  
  /**
   * int fflush(FILE *)
   */
  int fflush(stream) {
    return _library.invoke("fflush", [stream]);
  }
  
  /**
   * int fgetc(FILE *)
   */
  int fgetc(stream) {
    return _library.invoke("fgetc", [stream]);
  }
  
  /**
   * int fgetpos(FILE *, fpos_t *)
   */
  int fgetpos(stream, position) {
    return _library.invoke("fgetpos", [stream, position]);
  }
  
  /**
   * char * fgets(char *, int, FILE *)
   */
  BinaryData fgets(s, int count, stream) {
    return _library.invoke("fgets", [s, count, stream]);
  }
  
  /**
   * FILE * fopen(char *, char *)
   */
  BinaryData fopen(filename, opentype) {
    return _library.invoke("fopen", [filename, opentype]);
  }
  
  /**
   * int fprintf(FILE *, char *, ...)
   */
  int fprintf(stream, template, [List params]) {
    var arguments = [stream, template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("fprintf", arguments);
  }
  
  /**
   * int fputc(int, FILE *)
   */
  int fputc(int c, stream) {
    return _library.invoke("fputc", [c, stream]);
  }
  
  /**
   * int fputs(char *, FILE *)
   */
  int fputs(s, stream) {
    return _library.invoke("fputs", [s, stream]);
  }
  
  /**
   * size_t fread(void *, size_t, size_t, FILE *)
   */
  int fread(data, int size, int count, stream) {
    return _library.invoke("fread", [data, size, count, stream]);
  }
  
  /**
   * FILE * freopen(char *, char *, FILE *)
   */
  BinaryData freopen(filename, opentype, stream) {
    return _library.invoke("freopen", [filename, opentype, stream]);
  }
  
  /**
   * int fscanf(FILE *, char *, ...)
   */
  int fscanf(stream, template, [List params]) {
    var arguments = [stream, template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("fscanf", arguments);
  }
  
  /**
   * int fseek(FILE *, long int, int)
   */
  int fseek(stream, int offset, int whence) {
    return _library.invoke("fseek", [stream, offset, whence]);
  }
  
  /**
   * int fsetpos(FILE *, fpos_t *)
   */
  int fsetpos(stream, position) {
    return _library.invoke("fsetpos", [stream, position]);
  }
  
  /**
   * long int ftell(FILE *)
   */
  int ftell(stream) {
    return _library.invoke("ftell", [stream]);
  }
  
  /**
   * size_t fwrite(void *, size_t, size_t, FILE *)
   */
  int fwrite(data, int size, int count, stream) {
    return _library.invoke("fwrite", [data, size, count, stream]);
  }
  
  /**
   * int getc(FILE *)
   */
  int getc(stream) {
    return _library.invoke("getc", [stream]);
  }
  
  /**
   * int getchar()
   */
  int getchar() {
    return _library.invoke("getchar", []);
  }
  
  /**
   * char * gets(char *)
   */
  BinaryData gets(s) {
    return _library.invoke("gets", [s]);
  }
  
  /**
   * void perror(char *)
   */
  void perror(message) {
    return _library.invoke("perror", [message]);
  }
  
  /**
   * int printf(char *, ...)
   */
  int printf(template, [List params]) {
    var arguments = [template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("printf", arguments);
  }
  
  /**
   * int putc(int, FILE *)
   */
  int putc(int c, stream) {
    return _library.invoke("putc", [c, stream]);
  }
  
  /**
   * int putchar(int)
   */
  int putchar(int c) {
    return _library.invoke("putchar", [c]);
  }
  
  /**
   * int puts(char *)
   */
  int puts(s) {
    return _library.invoke("puts", [s]);
  }
  
  /**
   * int remove(char *)
   */
  int remove(filename) {
    return _library.invoke("remove", [filename]);
  }
  
  /**
   * int rename(char *, char *)
   */
  int rename(oldname, newname) {
    return _library.invoke("rename", [oldname, newname]);
  }
  
  /**
   * void rewind(FILE *)
   */
  void rewind(stream) {
    return _library.invoke("rewind", [stream]);
  }
  
  /**
   * int scanf(char *, ...)
   */
  int scanf(template, [List params]) {
    var arguments = [template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("scanf", arguments);
  }
  
  /**
   * void setbuf(FILE *, char *)
   */
  void setbuf(stream, buf) {
    return _library.invoke("setbuf", [stream, buf]);
  }
  
  /**
   * int setvbuf(FILE *, char *, int, size_t)
   */
  int setvbuf(stream, buf, int mode, int size) {
    return _library.invoke("setvbuf", [stream, buf, mode, size]);
  }
  
  /**
   * int snprintf(char *, size_t, char *, ...)
   */
  int snprintf(s, int size, template, [List params]) {
    var arguments = [s, size, template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("snprintf", arguments);
  }
  
  /**
   * int sprintf(char *, char *, ...)
   */
  int sprintf(s, template, [List params]) {
    var arguments = [s, template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("sprintf", arguments);
  }
  
  /**
   * int sscanf(char *, char *, ...)
   */
  int sscanf(s, template, [List params]) {
    var arguments = [s, template];
    if (params != null) {
      arguments.addAll(params);
    }
    
    return _library.invoke("sscanf", arguments);
  }
  
  /**
   * FILE * tmpfile()
   */
  BinaryData tmpfile() {
    return _library.invoke("tmpfile", []);
  }
  
  /**
   * char * tmpnam(char *)
   */
  BinaryData tmpnam(result) {
    return _library.invoke("tmpnam", [result]);
  }
  
  /**
   * int ungetc(int, FILE *)
   */
  int ungetc(int c, stream) {
    return _library.invoke("ungetc", [c, stream]);
  }
  
  /**
   * int vfprintf(FILE *, char *, va_list)
   */
  int vfprintf(stream, template, ap) {
    return _library.invoke("vfprintf", [stream, template, ap]);
  }
  
  /**
   * int vfscanf(FILE *, char *, va_list)
   */
  int vfscanf(stream, template, ap) {
    return _library.invoke("vfscanf", [stream, template, ap]);
  }
  
  /**
   * int vprintf(char *, va_list)
   */
  int vprintf(template, ap) {
    return _library.invoke("vprintf", [template, ap]);
  }
  
  /**
   * int vscanf(char *, va_list)
   */
  int vscanf(template, ap) {
    return _library.invoke("vscanf", [template, ap]);
  }
  
  /**
   * int vsprintf(char *, char *, va_list)
   */
  int vsprintf(s, template, ap) {
    return _library.invoke("vsprintf", [s, template, ap]);
  }
  
  /**
   * int vsscanf(char *, char *, va_list)
   */
  int vsscanf(s, template, ap) {
    return _library.invoke("vsscanf", [s, template, ap]);
  }
  
}

